// Type definitions for appium-adb 8.16
// Project: https://github.com/appium/appium-adb
// Definitions by: Tiger Oakes <https://github.com/NotWoods>
// Definitions: https://github.com/DefinitelyTyped/DefinitelyTyped

import {
    ADB,
    DEFAULT_ADB_PORT,
    getAndroidBinaryPath,
    getSdkRootFromEnv,
    AdbExecutable,
    CreateAdbOptions
} from './lib/adb';
import {
    LogcatOpts,
    SetPropOptions,
    ScreenrecordOptions,
    APKInfo,
    CertCheckOptions,
    KeystoreHash,
    Device,
    AdbExecOptions,
    ExecResult,
    ShellExecOptions,
    AvdLaunchOptions,
    BinaryVersion,
    BridgeVersion,
    Version,
    RootResult,
    BinaryName,
    StartAppOptions,
    StartUriOptions,
    PackageActivityInfo,
    UninstallOptions,
    CachingOptions,
    InstallOptions,
    InstallOrUpgradeOptions,
    InstallOrUpgradeResult,
    AppInfo,
    InstallApksOptions,
    EmuInfo,
    ExecTelnetOptions,
    EmuVersionInfo,
    SettingsAppStartupOptions,
    Location,
    SmsListOptions,
    StatusBarNotification,
    SmsItem,
    KeyboardState,
} from './lib/tools';

export default ADB;
export {
    ADB,
    DEFAULT_ADB_PORT,
    getAndroidBinaryPath,
    getSdkRootFromEnv,
    AdbExecutable,
    CreateAdbOptions,
    LogcatOpts,
    SetPropOptions,
    ScreenrecordOptions,
    APKInfo,
    CertCheckOptions,
    KeystoreHash,
    Device,
    AdbExecOptions,
    ExecResult,
    ShellExecOptions,
    AvdLaunchOptions,
    BinaryVersion,
    BridgeVersion,
    Version,
    RootResult,
    BinaryName,
    StartAppOptions,
    StartUriOptions,
    PackageActivityInfo,
    UninstallOptions,
    CachingOptions,
    InstallOptions,
    InstallOrUpgradeOptions,
    InstallOrUpgradeResult,
    AppInfo,
    InstallApksOptions,
    EmuInfo,
    ExecTelnetOptions,
    EmuVersionInfo,
    SettingsAppStartupOptions,
    Location,
    SmsListOptions,
    StatusBarNotification,
    SmsItem,
    KeyboardState,
};
